<template>
  <div>
    <h3># of questions</h3>

    <input
      type="number"
      placeholder="10"
      @change="changedNumberQuestions($event)"
    />

    <h3>Select Difficulty</h3>
    <select @change="selectDifficulty($event)">
      <option value="easy">Easy</option>
      <option value="medium">Medium</option>
      <option value="hard">Hard</option>
    </select>

    <h3>Select catagory</h3>
    <select @change="selectCatagory($event)">
      <option v-for="catagory in catagoryList" :key="catagory.id">
        {{ catagory.name }}
      </option>
    </select>

    <br />
    <button @click="startQ">Start the Quiz</button>
  </div>
</template>

<script>
import { mapState, mapActions, mapMutations } from "vuex";

export default {
  computed: {
    //data from store retreving, to be used in template
    ...mapState([
      "selectedCatagory",
      "catagoryList",
      "numberOfQuestions",
      "activeScreen",
    ]),
  },
  methods: {
    ...mapActions(["getCatagory", "getListOfQuestions"]),
    ...mapMutations([
      "changeCatagory",
      "setNumberOfQuestions",
      "changeDifficulty",
      "changeActiveScreen",
    ]),
    selectCatagory(event) {
      this.changeCatagory(event.target.value);
    },

    changedNumberQuestions(event) {
      this.setNumberOfQuestions(event.target.value);
    },
    selectDifficulty(event) {
      this.changeDifficulty(event.target.value);
    },
    startQ() {
      this.changeActiveScreen("questions"); //I know, not DRY
      this.$emit("Change-Screen", "questions"); //use emit because property is needed in App.vue
      this.getListOfQuestions();
    },
  },
    async created() {
      await this.getCatagory();
      await this.getListOfQuestions(); //fetch api, to fill up the questionList object

    },
  
};
</script>

<style>
</style>